function formula() {
}

formula.$id = 0;
formula.$lvl = 1;
formula.$results = {};
formula.$names = {};
formula.$X = {};

formula.add = function()
{
    formula.$id++;
    var $fblock = $('<div id="f' + formula.$id + '" class="formula-block" />');
    var $name = $('<input class="formula-name" type="text" placeholder="Название формулы" />');
    $fblock.append($name);
    var $clearblock = $('<div class="clear"/>');
    var $varblock = $('<div class="var-block" />');
    var $title = $('<span>Базовое значение</span>');
    var $value = $('<input id="base" type="text"/>');
    $value.addClass('fval-input');
    $value.val('0');
    formula.input_rules_init($value);
    $clearblock = $('<div class="clear"/>');
    $varblock.append($title).append($value).append($clearblock);
    $fblock.append($varblock);
    $varblock = $('<div class="var-block" />');
    $title = $('<span>Предыдущее значение</span>');
    $value = $('<input id="prev" type="text"/>');
    $value.addClass('fval-input');
    $value.val('1');
    formula.input_rules_init($value);
    $clearblock = $('<div class="clear"/>');
    $varblock.append($title).append($value).append($clearblock);
    $fblock.append($varblock);
    $varblock = $('<div class="var-block" />');
    $title = $('<span>Фактор уровня</span>');
    $value = $('<input id="lvl" type="text"/>');
    $value.addClass('fval-input');
    $value.val('0');
    formula.input_rules_init($value);
    $clearblock = $('<div class="clear"/>');
    $varblock.append($title).append($value).append($clearblock);
    $fblock.append($varblock);
    $varblock = $('<div class="var-block" />');
    $title = $('<span>Фактор константы</span>');
    $value = $('<input id="const" type="text"/>');
    $value.addClass('fval-input');
    $value.val('0');
    formula.input_rules_init($value);
    $clearblock = $('<div class="clear"/>');
    
    $varblock.append($title).append($value).append($clearblock);
    $fblock.append($varblock);

    var $dopvars = $('<div class="dop-vars" />');
    var $span = $('<span>Выводить значения для всех уровней через разделитель</span>');
    var $chb = $('<input id="_cb" type="checkbox"  />');
    $chb.click(function()
    {
        var $ch = $(this).prop('checked');
        if ($ch)
        {
            $(this).parent().next('.dop-vars').removeClass('hide');
        }
        else
        {
            $(this).parent().next('.dop-vars').addClass('hide');
        }
        generate_view.auto_generate();
    });
    var $prefix = $('<input id="_prefix" type="text" maxlength="5" placeholder="Разделитель"/>');
    $prefix.keyup(function()
    {
        generate_view.auto_generate();
    });
    var $span2 = $('<span>Отсекать остаток </span>');
    var $chbround = $('<input id="_chround" type="checkbox" />');
    $chbround.click(function()
    {
        generate_view.auto_generate();
    });
    $dopvars.append($span2).append($chbround).append('<br/>').append($span).append($chb).append($prefix);
    $fblock.append($dopvars);
    $dopvars = $('<div class="dop-vars hide" />');
    $span = $('<span>При выводе всех значений подкрашивать текущее значение</span>');
    $chb = $('<input id="_chcolor" type="checkbox" />');
    $chb.click(function()
    {
        generate_view.auto_generate();
    });
    var $colorblock = $('<div class="color" tcolor="ffffff" style="background: #fff;"></div>');
    $colorblock.mouseup(function()
    {
        generate_view.auto_generate();
    });
    colors.init_set_color_up($colorblock);
    colors.init_drag($colorblock);
    
    $dopvars.append($span).append($chb).append($colorblock);
    $fblock.append($dopvars);

    $('#formuls_in_block').append($fblock);
    $fblock.find('input').mousedown(function($e)
    {
        $e.stopPropagation();
    });

    return $fblock;
};

formula.create = function($name, $a, $b, $c, $d, $ch1, $prefix, $ch2, $tcolor, $ch3)
{
    var $fblock = formula.add();
    $fblock.find('.formula-name').val($name);
    $fblock.find('#base').val($a);
    $fblock.find('#prev').val($b);
    $fblock.find('#lvl').val($c);
    $fblock.find('#const').val($d);
    if ($ch1 === 'true')
    {
        $fblock.find('#_cb').attr('checked', 'checked');
        $fblock.find('.dop-vars:last').removeClass('hide');
    }
    else
        $fblock.find('#_cb').removeAttr('checked');
    $fblock.find('#_prefix').val($prefix);
    if ($ch2 === 'true')
        $fblock.find('#_chcolor').attr('checked', 'checked');
    else
        $fblock.find('#_chcolor').removeAttr('checked');
    if ($ch3 === 'true')
        $fblock.find('#_chround').attr('checked', 'checked');
    else
        $fblock.find('#_chround').removeAttr('checked');

    var $color_block = $fblock.find('.color');
    $color_block.attr('tcolor', $tcolor);
    $color_block.attr('title', '#' + $tcolor);
    $color_block.css('background', '#' + $tcolor);
};

formula.input_rules_init = function($inp, $std)
{
    $std = typeof $std !== 'undefined' ? $std : 0;
    $inp.on('change', function()
    {
        $(this).val(formula.rounded(parseFloat($(this).val())));
        if ($(this).val() === '')
        {
            $(this).val($std);
        }
        else if (isNaN($(this).val()))
        {
            $(this).val($std);
        }

        if ($(this).attr('id') === 'base' && parseInt($(this).val()) < 0)
        {
            $(this).val(0);
        }
        else if ($(this).attr('id') === 'prev' && parseInt($(this).val()) < 0)
        {
            $(this).val(0);
        }

        generate_view.text_parsing();
    });

};

formula.insert_window = function($text_element, $pos)
{
    var $list = $('<div class="insert-formula-list" />');
    $('.formula-block').each(function()
    {
        var $name = $(this).find('.formula-name').val();
        var $item = $('<span>' + $name + '</span>');
        $list.append($item);
        $item.click(function()
        {
            $list.remove();
            var $s = $text_element.val();
            $s = $s.substr(0, $pos - 2) + '[' + $name + ']' + $s.substring($pos, $s.length);
            $text_element.val($s);
            generate_view.text_parsing();
            $text_element.focus();
            insert.setCaretPosition($text_element, $pos + $name.length);
            return false;
        });
    });

    var $item = $('<span>Закрыть</span>');
    $item.click(function()
    {
        $list.remove();
        var $s = $text_element.val();
        $s = $s.substr(0, $pos - 2) + $s.substring($pos, $s.length);
        $text_element.val($s);
        generate_view.text_parsing();
        $text_element.focus();
        insert.setCaretPosition($text_element, $pos);
        return false;
    });
    $list.append($item);

    $('body').append($list);
    $list.css({top: main.$mouse.y, left: main.$mouse.x});
};

formula.rounded = function($v)
{
    return parseInt($v * 100) / 100;
};

formula.generate_result_value = function($a, $b, $c, $d, $lvl, $id, $chbround)
{
    formula.$X[$id] = typeof formula.$X[$id] === 'undefined' ? formula.$X[$id] = {} : formula.$X[$id];
    $lvl = parseInt($lvl);
    var $result_val = 0;
    if ($lvl === 1)
    {
        $result_val = formula.$X[$id][$lvl] = $a;
    }
    else
    {
        $result_val = formula.$X[$id][$lvl] = formula.$X[$id][$lvl - 1] * $b + $lvl * $c + $d;
    }
    
    if ($chbround)
    {
        $result_val = parseInt($result_val);
    }

    return formula.rounded($result_val);
};

formula.generate_result_text = function($formula)
{
    var $a = $formula.find('#base').val();
    $a = parseFloat($a);
    var $b = $formula.find('#prev').val();
    $b = parseFloat($b);
    var $c = $formula.find('#lvl').val();
    $c = parseFloat($c);
    var $d = $formula.find('#const').val();
    $d = parseFloat($d);

    var $chcolor = $formula.find('#_chcolor').prop('checked');
    var $tcolor = $formula.find('.color').attr('tcolor');
    var $prefix = $formula.find('#_prefix').val();
    var $chb = $formula.find('#_cb').prop('checked');
    var $chbround = $formula.find('#_chround').prop('checked');
    var $result_text = {};
    $result_text.WE = '';
    $result_text.HTML = '';
    var $id = $formula.attr('id');
    if ($chb)
    {
        for (var $i = 1; $i <= lvls.$maxLvl; $i++)
        {
            if ($i === formula.$lvl && $chcolor)
            {
                $result_text.WE += '|cff' + $tcolor;
                $result_text.HTML += '<span style="color: #' + $tcolor + '">';
            }
            var $fr = formula.generate_result_value($a, $b, $c, $d, $i, $id, $chbround).toString(10);
            $result_text.WE += $fr;
            $result_text.HTML += $fr;
            if ($i === formula.$lvl && $chcolor)
            {
                $result_text.WE += '|r';
                $result_text.HTML += '</span>';
            }
            if ($i < lvls.$maxLvl)
            {
                $result_text.WE += $prefix;
                $result_text.HTML += $prefix;
            }
        }
        return $result_text;
    }
    else
    {
        for (var $i = 1; $i <= lvls.$maxLvl; $i++)
        {
            formula.generate_result_value($a, $b, $c, $d, $i, $id, $chbround);
        }
        $result_text.WE = $result_text.HTML = formula.generate_result_value($a, $b, $c, $d, formula.$lvl, $id, $chbround);
        return $result_text;
    }
};

formula.formuls_parsing_results = function()
{
    formula.$names = {}; // сохраняем названия всех формул для вывода и поиска
    formula.$results = {};// сохраняем результаты всех формул чтобы обращаться к ним при замене номеров 
    $('.formula-block').each(function()
    {
        var $id = $(this).attr('id');
        formula.$results[$id] = formula.generate_result_text($(this));
        formula.$names[$id] = $(this).find('.formula-name').val();
    });
};

(function($)
{
    $('#add_formula').click(function()
    {
        formula.add();
    });
})(jQuery);

