function generate_view() {
}

generate_view.$WE = {};
generate_view.$formulaText = {};
generate_view.$time = null;

generate_view.prompt = function($type)
{
    generate_view.text_parsing();
    if ($type === 'head')
    {
        window.prompt('Код для ОПИСАНИЯ ' + formula.$lvl + ' уровня.', generate_view.$WE.head);
    }
    else
    {
        window.prompt('Код для ОПИСАНИЯ ' + formula.$lvl + ' уровня.', generate_view.$WE.body);
    }
};

generate_view.auto_generate = function()
{
    if (generate_view.$time !== null)
    {
        clearTimeout(generate_view.$time);
    }
    
    var $current_focus = $('input[type="text"]:focus, textarea:focus');
    var $carPos = insert.getCaretPosition($current_focus);
    
    generate_view.$time = setTimeout(function()
    {
        clearTimeout(generate_view.$time);
        generate_view.$time = null;
        generate_view.text_parsing();
        insert.setCaretPosition($current_focus, $carPos);
    }, 500);
};

generate_view.generate = function()
{
    generate_view.$WE = {};
    generate_view.text_parsing();
};

generate_view.text_parsing = function() /* полный проход по всему и вывод финальных текстов */
{
    $('.fval-input').blur();
    formula.formuls_parsing_results(); //перепрощет всех формул и сохранение в массив по f1,f2,f3
    generate_view.number_parsing();
};

generate_view.number_parsing = function()
{
    var $VW = $('#view_window');
    var $so = generate_view.number_parsing_element($('#main_name').val());
    generate_view.$WE.head = Pregs.pregs_simbols($so.WE);
    $VW.find('.header').html($so.HTML);
    var $so = generate_view.number_parsing_element($('#main_description').val());
    generate_view.$WE.body = Pregs.pregs_simbols($so.WE);
    $VW.find('.description').html($so.HTML);
    generate_view.WE_clearing();
    generate_view.init_events();
    $('#_head_length').text(generate_view.$WE.head.length);
    $('#_body_length').text(generate_view.$WE.body.length);
};

generate_view.WE_clearing = function()
{
    var $preg1 = /\|r\|r/g;
    var $preg2 = /\|cff.{6}\s{0,}\|cff/g;
    var $preg3 = /\|cff.{6}\s{0,}\|r/g;
    var $preg4 = /\|r\|c/g;
    var $preg5 = /\|cff.{6}$/g;
    generate_view.$WE.head = generate_view.$WE.head.replace($preg3, '');
    generate_view.$WE.body = generate_view.$WE.body.replace($preg3, '');
    generate_view.$WE.head = generate_view.$WE.head.replace($preg1, '|r');
    generate_view.$WE.body = generate_view.$WE.body.replace($preg1, '|r');
    generate_view.$WE.head = generate_view.$WE.head.replace($preg2, '|cff');
    generate_view.$WE.body = generate_view.$WE.body.replace($preg2, '|cff');
    generate_view.$WE.head = generate_view.$WE.head.replace($preg4, '|c');
    generate_view.$WE.body = generate_view.$WE.body.replace($preg4, '|c');
    generate_view.$WE.head = generate_view.$WE.head.replace($preg5, '');
    generate_view.$WE.body = generate_view.$WE.body.replace($preg5, '');
};

generate_view.number_parsing_element = function($text)
{
    var $ret = {};
    $ret.WE = generate_view.number_parsing_element_we($text);
    var $rreg = /(\s{1,})/g;
    //$text = $text.replace($rreg, '<pre>$1</pre>');
    $ret.HTML = generate_view.number_parsing_element_html($text);
    return $ret;
};

generate_view.number_parsing_element_html = function($text)
{
    var $preg = /№[0-9]{1,2}/g;
    var $result = $text.match($preg);
    if ($result !== null)
    {
        var $start = 0;
        for (var $i = 0; $i < $result.length; $i++)
        {
            var $sid = $result[$i];
            var $id = parseInt($sid.substring(1, $sid.length));
            var $pole_block = $('#pole' + $id);
            var $number_text = $pole_block.find('.pole').val();
            var $tcolor = $pole_block.find('.color').attr('tcolor');
            var $index = $text.indexOf($result[$i], $start);
            $text = $text.substr(0, $index) + '<span class="vspan" id="sp' + $id + '" number="' + $id + '" style="color: #' + $tcolor + '">' + $number_text + '</span>' + $text.substring($index + $result[$i].length, $text.length);
            $start += 2;
        }
    }

    for (var $id in formula.$names)
    {
        var $fname = '[' + formula.$names[$id] + ']';
        var $index = 0;
        while ($index !== -1)
        {
            $index = $text.indexOf($fname);
            if ($index !== -1)
            {
                $text = $text.substr(0, $index) + formula.$results[$id].HTML + $text.substring($index + $fname.length, $text.length);
            }
        }
    }

    var $rreg = /\n/g;
    $text = $text.replace($rreg, '<br/>');

    if ($text.match($preg))
    {
        $text = generate_view.number_parsing_element_html($text);
    }

    return $text;
};

generate_view.formula_parent_color_inset = function($s, $parent_color)
{
    $s = $s.toString();
    var $preg = /\|r/;
    var $parent = $parent_color !== '' ? '|cff' + $parent_color : '';
    $s = $s.replace($preg, $parent);

    return $s;
};

generate_view.number_parsing_element_we = function($text, $parent_color)
{
    $parent_color = typeof $parent_color === 'undefined' ? '' : $parent_color;
    var $preg = /№[0-9]{1,2}/g;
    var $result = $text.match($preg);
    var $tcolor = '';
    if ($result !== null)
    {
        var $start = 0;
        for (var $i = 0; $i < $result.length; $i++)
        {
            var $sid = $result[$i];
            var $id = parseInt($sid.substring(1, $sid.length));
            var $pole_block = $('#pole' + $id);
            var $number_text = $pole_block.find('.pole').val();
            $tcolor = $pole_block.find('.color').attr('tcolor');
            var $index = $text.indexOf($result[$i], $start);
            var $parent = $parent_color !== '' ? '|cff' + $parent_color : '';
            $text = $text.substr(0, $index) + '|cff' + $tcolor + $number_text + '|r' + $parent + $text.substring($index + $result[$i].length, $text.length);
            $start += 1;
        }
    }

    for (var $id in formula.$names)
    {
        var $fname = '[' + formula.$names[$id] + ']';
        var $index = 0;
        while ($index !== -1)
        {
            $index = $text.indexOf($fname);
            if ($index !== -1)
            {
                var $r = generate_view.formula_parent_color_inset(formula.$results[$id].WE, $tcolor);
                $text = $text.substr(0, $index) + $r + $text.substring($index + $fname.length, $text.length);
            }
        }
    }

    var $rreg = /\n/g;
    $text = $text.replace($rreg, '|n');

    if ($text.match($preg))
    {
        $text = generate_view.number_parsing_element_we($text, $tcolor);
    }

    return $text;
};

generate_view.init_events = function()
{
    $('.vspan').mouseup(function($e)
    {
        if (colors.$drag_object !== null)
        {
            var $id = $(this).attr('number');
            var $color_obj = $('#pole' + $id).find('.color');
            var $color = colors.$drag_object.text();
            $color_obj.attr('tcolor', $color);
            $color_obj.attr('title', '#' + $color);
            $color_obj.css('background', '#' + $color);
            $e.stopPropagation();
            $(document).mouseup();
            generate_view.generate();
        }

    }).hover(function()
    {
        if (colors.$drag_object !== null)
        {
            var $color = colors.$drag_object.text();
            $(this).data('stylecolor', $(this).css('color'));
            $(this).css('color', '#' + $color);

            var $p = $(this).parent();
            if ($p.data('stylecolor') !== null && typeof $p.data('stylecolor') !== 'undefined')
            {
                $p.css('color', $p.data('stylecolor'));
            }

            return false;
        }
    }, function()
    {
        if (colors.$drag_object !== null)
        {
            $(this).css('color', $(this).data('stylecolor'));
            $(this).data('stylecolor', null);
        }
        else
        {
            generate_view.$last_child = null;
        }
    }).click(function()
    {
        var $id = $(this).attr('number');
        var $pole = $('#pole' + $id);
        $pole.find('.pole').focus();
        return false;
    });
};

generate_view.set_icon = function($n)
{

    if ($n === 0)
    {
        $('#_ico_ico').hide();
    }
    else if ($n === 1)
    {
        $('#_ico').css('background', 'url("i/mana.png") center no-repeat');
        $('#_ico_ico').show();
    }
    else if ($n === 2)
    {
        $('#_ico').css('background', 'url("i/gold.png") center no-repeat');
        $('#_ico_ico').show();
    }
};

(function()
{
    $('#Rnone').click(function()
    {
        if ($(this).prop('checked'))
        {
            generate_view.set_icon(0);
        }
    }).prop('checked', 'checked').click();
    $('#Rmana').click(function()
    {
        if ($(this).prop('checked'))
        {
            generate_view.set_icon(1);
        }
    });
    $('#Rtree').click(function()
    {
        if ($(this).prop('checked'))
        {
            generate_view.set_icon(2);
        }
    });
})();