function drag_window() {
}

drag_window.$drag = false;
drag_window.$drag_object = null;
drag_window.$zIndexTimer = null;

drag_window.$set_drag = function($e)
{
    drag_window.$drag = true;
    drag_window.$drag_object = $e;
};

(function($)
{
    $('.window').mousedown(function($e)
    {
        $(this).find('textarea:focus, input:focus, button:focus').blur();
        if (window.getSelection)
        {
            window.getSelection().removeAllRanges();
        }
        var $offsetX = parseInt($(this).css('left')) - $e.pageX;
        var $offsetY = parseInt($(this).css('top')) - $e.pageY;
        $(this).data({mousedown: true, x: $e.pageX, y: $e.pageY, offsetX: $offsetX, offsetY: $offsetY});

        return false;
    }).mouseup(function()
    {
        $(this).data('mousedown', false);
    }).mousemove(function($e)
    {
        if (Math.abs($(this).data('x') - $e.pageX) + Math.abs($(this).data('y') - $e.pageY) > 2 && $(this).data('mousedown') && !drag_window.$drag)
        {
            drag_window.$set_drag($(this));
        }
    }).mouseleave(function()
    {
        if ($(this).data('mousedown') && !drag_window.$drag)
        {
            drag_window.$set_drag($(this));
        }
    }).each(function()
    {
        $(this).find('textarea, input, button, span').mousedown(function($e)
        {
            $e.stopPropagation();
        });

    }).hover(function()
    {
        if (!drag_window.$drag)
        {
            if (drag_window.$zIndexTimer !== null)
            {
                clearTimeout(drag_window.$zIndexTimer);
            }
            
            var $w = $(this);
            drag_window.$zIndexTimer = setTimeout(function()
            {
                $('.window').css({'z-index': 0, opacity: 0.9});
                $w.css({'z-index': 1, opacity: 1});
                drag_window.$zIndexTimer = null;
            }, 500);
        }
    });

    $(document).mouseup(function()
    {
        drag_window.$drag = false;
        if (drag_window.$drag_object !== null)
        {
            drag_window.$drag_object.data('mousedown', false);
        }
        drag_window.$drag_object = null;
    }).mousemove(function($e)
    {
        if (drag_window.$drag && drag_window.$drag_object !== null)
        {
            var $x = $e.pageX + drag_window.$drag_object.data('offsetX');
            var $y = $e.pageY + drag_window.$drag_object.data('offsetY');
            drag_window.$drag_object.css({top: $y, left: $x});
        }
    }).mousedown(function()
    {
        $(this).find('textarea:focus, input:focus, button:focus').blur();

        if (window.getSelection)
        {
            window.getSelection().removeAllRanges();
        }

        return false;
    });

    $('#main_name, #main_description').click(function()
    {
        insert.$back_path = {};
    });

})(jQuery);

