function insert() {
}

insert.$SHIFT = false;
insert.$CTRL = false;
insert.$CN = 0;
insert.$coffs = 0;
insert.$last_map = [];
insert.$auto_number_refresh = null;
insert.$back_path = {};


insert.setCaretPosition = function($text_element, $position)
{
    $text_element = typeof $text_element[0] !== 'undefined' ? $text_element[0] : $text_element;
    if ($text_element.setSelectionRange)
    {
        $text_element.focus();
        $text_element.setSelectionRange($position, $position);
    }
    else if ($text_element.createTextRange)
    {
        var range = $text_element.createTextRange();
        range.collapse(true);
        range.moveEnd('character', $position);
        range.moveStart('character', $position);
        range.select();
    }
};

insert.getCaretPosition = function($text_element)
{
    $text_element = typeof $text_element[0] !== 'undefined' ? $text_element[0] : $text_element;
    var CaretPos = 0;
    if (document.selection)
    {
        $text_element.focus();
        var Sel = document.selection.createRange();
        Sel.moveStart('character', $text_element.value.length);
        CaretPos = Sel.text.length;
    }
    else if ($text_element.selectionStart || $text_element.selectionStart === '0')
        CaretPos = $text_element.selectionStart;
    return (CaretPos);
};

insert.sort_numbers = function($text_element_or_pole)
{
    var $s = $text_element_or_pole.val();
    var $preg = /№[0-9]{1,2}/g;
    var $result = $s.match($preg);
    var $start = 0;
    if ($result !== null)
    {
        for (var $i = 0; $i < $result.length; $i++)
        {
            insert.$CN++;
            if ($result[$i] !== '№' + insert.$CN)
            {
                if ($('#pole' + insert.$CN).length === 0 || $result[$i] === '№0')
                {
                    insert.create_pole('', insert.$CN, null);
                }
                if ($result[$i] === '№0')
                {
                    insert.$coffs = insert.$CN < 10 ? 1 : 2;
                }
                var $index = $s.indexOf($result[$i], $start);
                if ($index !== -1)
                {
                    var $offset = $result[$i].length;
                    $s = $s.substr(0, $index + 1) + insert.$CN + $s.substring($index + $offset, $s.length);
                    $start = $index + 1;
                }
            }
            else
            {
                var $index = $s.indexOf($result[$i], $start);
                var $offset = $result[$i].length;
                $start = $index + $offset;
            }
            insert.$last_map.push('№' + insert.$CN);
        }
        //console.log('==============================');
        $text_element_or_pole.val($s);
    }
};

insert.delete_after_lost = function($i)
{
    $('.pole-block').each(function()
    {
        if (parseInt($(this).attr('pos')) > $i)
        {
            console.log('last remove pos = ' + $(this).attr('pos'));
            $(this).remove();
        }
    });
};

insert.delete_poles = function()/* Находит несоответсвие номеров и удаляет несуществующие номера */
{
    var $new_map = [];
    var $preg = /№[0-9]{1,2}/g;
    $new_map.push($('#main_name').val().match($preg));
    $new_map.push($('#main_description').val().match($preg));

    $('.pole').each(function()
    {
        $new_map.push($(this).val().match($preg));
    });

    var $result_new_map = [];
    for (var $i = 0; $i < $new_map.length; $i++)
    {
        if ($new_map[$i] !== null)
        {
            for (var $ii = 0; $ii < $new_map[$i].length; $ii++)
            {
                $result_new_map.push($new_map[$i][$ii]);
            }
        }
    }

//    console.log($result_new_map);
//    console.log(insert.$last_map);

    var $n = 0;
    var $fail_start = -1;
    var $newid = -1; /* после сращивания провала, все элементы после конца провала получают новый id */
    for (var $i = 0; $i < insert.$last_map.length; $i++)
    {
        if ($result_new_map[$n] === '№0')
            $n++;
        if (insert.$last_map[$i] === $result_new_map[$n])
        {
            $n++;
            if ($fail_start !== -1) /* перенос конца провала в начало провала */
            {
                var $k = $i + 1;
                var $p = $('#pole' + $k);
                $p.attr('id', 'pole' + $fail_start).attr('pos', $fail_start);
                $p.find('.number').text('№' + $fail_start);
                $newid = $fail_start + 1;
                $fail_start = -1;
            }
            else if ($newid > -1)
            {
                var $k = $i + 1;
                var $p = $('#pole' + $k);
                $p.attr('id', 'pole' + $newid).attr('pos', $newid);
                $p.find('.number').text('№' + $newid);
                $newid++;
            }
        }
        else if (insert.$last_map[$i] !== $result_new_map[$n])
        {
            var $k = $i + 1;
            if ($fail_start === -1) /*начало провала*/
            {
                $fail_start = $k;
            }
            $('#pole' + $k).remove();
        }
    }
};

insert.global_numbers_sorting = function()
{
    insert.delete_poles();
    insert.$CN = 0;
    insert.$last_map = [];
    insert.sort_numbers($('#main_name'));
    insert.sort_numbers($('#main_description'));
    $('.pole').each(function()
    {
        insert.sort_numbers($(this));
    });
    insert.delete_after_lost(insert.$CN);
    generate_view.generate();
};

insert.insert_pole = function($position)
{
    var $p = $('#pole' + $position);
    var $newpos = $position + 1;
    if ($p.length > 0)
    {
        insert.insert_pole($newpos);
    }
    $p.attr('id', 'pole' + $newpos);
    $p.attr('pos', $newpos);
    $p.find('.number').text('№' + $newpos);
    $p = $('#pole' + $newpos);
};

insert.create_pole = function($text, $position, $color)
{
    var $poles_blocks = $('#poles_blocks');
    var $p = $('#pole' + $position);
    $position = $p.length > 0 ? $position : $poles_blocks.children('.pole-block').length + 1;

    var $pole_block = $('<div id="pole' + $position + '" pos="' + $position + '" class="pole-block"/>');
    $pole_block.mousedown(function($e)
    {
        $e.stopPropagation();
    });
    var $numb = $('<span  class="number">№' + $position + '</span>');
    var $textarea = $('<textarea class="pole" style="height: 20px; min-height: 20px;">' + $text + '</textarea>');
    $textarea.keyup(function($e)
    {
        insert.init_text_numb($(this), $e);
    });
    $color = typeof $color !== 'undefined' && $color !== null ? $color : 'ffffff';
    var $color_element = $('<div class="color" tcolor="' + $color + '" />');
    $color_element.css('background', '#' + $color);
    $color_element.attr('title', '#' + $color);
    $color_element.mousedown(function()
    {
        return false;
    }).mouseup(function()
    {
        if (colors.$drag_object !== null)
        {
            $(this).attr('tcolor', colors.$drag_object.attr('tcolor'));
            $(this).css('background', '#' + colors.$drag_object.attr('tcolor'));
            $color_element.attr('title', '#' + colors.$drag_object.attr('tcolor'));
            generate_view.generate();
        }
    });
    colors.init_drag($color_element);
    $textarea.focus(function()
    {
        $(this).css({height: '100px', minHeight: '100px'});

    }).blur(function()
    {
        $(this).css({height: '20px', minHeight: '20px'});
    }).keydown(function($e)
    {
        if ($e.keyCode === 9)
        {
            insert.tab_press($(this));
        }
    }).mouseup(function()
    {
        if ($(this) !== insert.$back_path.element)
        {
            insert.$back_path = {};
        }
    });
    $pole_block.append($numb).append($textarea).append($color_element);

    if ($p.length > 0)
    {
        insert.insert_pole($position);
        $p.before($pole_block);
    }
    else
    {
        $poles_blocks.append($pole_block);
    }
};

insert.create_number = function($text_element, $pos)
{
    insert.global_numbers_sorting();
    insert.setCaretPosition($text_element, $pos + insert.$coffs); //ставить курсор после номера!!!
};

insert.init_text_numb = function($text_element, $e)
{
    if ($e.keyCode === 51) // insert №
    {
        var $s = $text_element.val();
        var $pos = insert.getCaretPosition($text_element);
        var $simbol = $s.charAt($pos - 1);
        if ($simbol === '№')
        {
            $s = $s.substr(0, $pos) + '0' + $s.substring($pos, $s.length);
            $text_element.val($s);
            insert.create_number($text_element, $pos);
        }
    }
    else if ($e.keyCode === 65) // inser formula
    {
        var $s = $text_element.val();
        var $pos = insert.getCaretPosition($text_element);
        var $simbol1 = $s.charAt($pos - 1);
        var $simbol2 = $s.charAt($pos - 2);
        if ($simbol1 === 'Ф' && $simbol2 === 'Ф')
        {
            formula.insert_window($text_element, $pos);
        }
    }
    else
    {
        if (insert.$auto_number_refresh !== null)
        {
            clearTimeout(insert.$auto_number_refresh);
        }
        insert.$auto_number_refresh = setTimeout(function()
        {
            clearTimeout(insert.$auto_number_refresh);
            insert.$auto_number_refresh = null;
            insert.global_numbers_sorting();
        }, 500);
    }
};

(function($)
{
    $(document).keydown(function($e)
    {
        if ($e.keyCode === 16 && !insert.$SHIFT)
        {
            insert.$SHIFT = true;
        }
        else if ($e.keyCode === 17 && !insert.$CTRL)
        {
            insert.$CTRL = true;
        }
    }).keyup(function($e)
    {
        if ($e.keyCode === 16 && insert.$SHIFT)
        {
            insert.$SHIFT = false;
        }
        else if ($e.keyCode === 17 && insert.$CTRL)
        {
            insert.$CTRL = false;
        }
    });


    $('#main_name, #main_description').keyup(function($e)
    {

        insert.init_text_numb($(this), $e);
    }).keydown(function($e)
    {
        if ($e.keyCode === 9)
        {
            insert.tab_press($(this));
            return false;
        }
    });

})(jQuery);

// for tab func get caret number

insert.tab_press = function($text_element)
{
    if (typeof insert.$back_path.element !== 'undefined')
    {
        setTimeout(function()
        {
            if (typeof insert.$back_path.element !== 'undefined')
            {
                insert.$back_path.element.focus();
                insert.setCaretPosition(insert.$back_path.element, insert.$back_path.pos);
            }
            insert.$back_path = {};
        }, 1);
    }
    else
    {
        var $pos = insert.getCaretPosition($text_element);
        var $s = $text_element.val().substring(0, $pos);
        var $li = $s.lastIndexOf('№');
        if ($pos - $li <= 3 && $li !== -1) // number true
        {
            var $id = parseInt($s.substring($li + 1, $pos));
            console.log('id= ' + $id);
            setTimeout(function()
            {
                $('#pole' + $id).find('.pole').focus();
            }, 1);


            insert.$back_path.element = $text_element;
            insert.$back_path.pos = $pos;

        }
        else
        {
            $text_element.next('*').focus();
        }
    }
};