function lvls() {
}

lvls.$maxLvl = 10;

lvls.init_btn = function($btn)
{
    $btn.hover(function()
    {
        formula.$lvl = parseInt($(this).attr('lvl'));
        generate_view.text_parsing();
    }).click(function()
    {
        generate_view.prompt('body');
        return false;
    });
};

lvls.input_rules_init = function($inp, $std)
{
    $std = typeof $std !== 'undefined' ? $std : 0;
    $inp.on('change', function()
    {
        $(this).val(formula.rounded(parseFloat($(this).val())));
        if ($(this).val() === '')
        {
            $(this).val($std);
        }
        else if (isNaN($(this).val()))
        {
            $(this).val($std);
        }

        lvls.$maxLvl = parseInt($(this).val());
        lvls.create_btns();
    });
};

lvls.create_btns = function()
{
    var $b = $('#lvls_block');
    $b.empty();

    for (var $i = 1; $i <= lvls.$maxLvl; $i++)
    {
        var $btn = $('<button class="btn" lvl="' + $i + '">L' + $i + '</button>');
        lvls.init_btn($btn);
        $b.append($btn);
    }
    
    $btn = $('<button class="btn all" title="Поочередно вывести все описания всех уровней">ALL</button>');
    $btn.click(function()
    {
        for(var $i = 1; $i <= lvls.$maxLvl; $i++)
        {
            formula.$lvl = $i;
            generate_view.prompt('body');
        }
    });
    var $cl = $('<div class="clear" />');
    $b.prepend($btn).append($cl);
};

(function()
{
    lvls.input_rules_init($('#maxLvl'), 10);
    lvls.create_btns();
})(jQuery);