function saveload() {
}

saveload.add_empty_item = function($name)
{
    var $item = $('<div class="save-load-item">');
    var $title = $('<span class="title">' + $name + '</span>');
    var $save = $('<button class="btn info-save" title="Сохранить сюда текущее описание">Save</button>');
    $save.click(function()
    {
        saveload.save($(this).parent());
        return false;
    });
    var $load = $('<button class="btn info-load" title="Загрузить ЭТО описание, заменив текущее">Load</button>');
    $load.click(function()
    {
        saveload.load($(this).parent());
        return false;
    });
    var $del = $('<button class="btn info-del" title="Удалить ЭТО описание">Del</button>');
    $del.click(function()
    {
        $(this).parent().remove();
        return false;
    });

    var $info_block = $('<div id="_info_block" class="" />');

    $item.append($title).append($save).append($load).append($del).append($info_block);
    $('#save_load_list').prepend($item);
};

saveload.save = function($item)
{
    var $info = $item.find('#_info_block');
    $info.empty();
    $info.attr('maxLvl', lvls.$maxLvl);
    $info.attr('main_name', $('#main_name').val());
    $info.attr('main_description', $('#main_description').val());
    $('.pole-block').each(function()
    {
        var $clone = $('<div class="pole-block-info" />');
        $clone.attr('pos', $(this).attr('pos'));
        $clone.attr('poletext', $(this).find('.pole').val());
        $clone.attr('tcolor', $(this).find('.color').attr('tcolor'));
        $info.append($clone);
    });

    $('.formula-block').each(function()
    {
        var $clone = $('<div class="formula-block-info" />');
        $clone.attr('name', $(this).find('.formula-name').val());
        $clone.attr('a', $(this).find('#base').val());
        $clone.attr('b', $(this).find('#prev').val());
        $clone.attr('c', $(this).find('#lvl').val());
        $clone.attr('d', $(this).find('#const').val());
        $clone.attr('ch1', $(this).find('#_cb').prop('checked'));
        $clone.attr('ch2', $(this).find('#_chcolor').prop('checked'));
        $clone.attr('ch3', $(this).find('#_chround').prop('checked'));
        $clone.attr('prefix', $(this).find('#_prefix').val());
        $clone.attr('tcolor', $(this).find('.color').attr('tcolor'));
        
        $info.append($clone);
    });

    alert('Сохранено');
};

saveload.load = function($item)
{
    
    if (!confirm('Загрузить ' + $item.find('.title').text() + ' ?'))
        return false;
    var $info = $item.find('#_info_block');
    var $poles_blocks = $('#poles_blocks');
    $poles_blocks.empty();
    $info.find('.pole-block-info').each(function()
    {
        var $text = $(this).attr('poletext');
        var $pos = $(this).attr('pos');
        var $color = $(this).attr('tcolor');
        insert.create_pole($text, $pos, $color);
    });

    $('#formuls_in_block').empty();
    $info.find('.formula-block-info').each(function()
    {
        var $name = $(this).attr('name');
        var $a = $(this).attr('a');
        var $b = $(this).attr('b');
        var $c = $(this).attr('c');
        var $d = $(this).attr('d');
        var $ch1 = $(this).attr('ch1');
        var $prefix = $(this).attr('prefix');
        var $ch2 = $(this).attr('ch2');
        var $tcolor = $(this).attr('tcolor');
        var $ch3 = $(this).attr('ch3');

        formula.create($name, $a, $b, $c, $d, $ch1, $prefix, $ch2, $tcolor, $ch3);
    });

    $('#main_name').val($info.attr('main_name'));
    $('#main_description').val($info.attr('main_description'));
    $('#maxLvl').val($info.attr('maxLvl'));
    $('#lvls_block').empty();
    lvls.create_btns();
    generate_view.text_parsing();
    var $title = $('#_load_title');
    if ($title.length > 0)
    {
        $title.html('<b>Сейчас загружен: </b><a href="#">' + $item.find('.title').text() + '</a>');
    }
    else
    {
        var $s = $('<span id="_load_title"><b>Сейчас загружен: </b><a href="#">' + $item.find('.title').text() + '</a></span>');
        $('#main_window').append($s);
        $s.click(function()
        {
            $('#_saveload_filter').val($(this).find('a').text()).keyup();
            return false;
        });
    }

};

(function($)
{
    $('#_saveload_filter').keyup(function()
    {
        var $find = $(this).val().toLowerCase();
        var $SL = $('#save_load');
        $SL.find('.save-load-item').each(function()
        {
            var $this_name = $(this).children('.title').text().toLowerCase();
            if ($this_name.indexOf($find) === -1)
            {
                $(this).hide();
            }
            else
            {
                $(this).show();
            }
        });
    });
    $('#_saveload_filter').val('').keyup();
    

    $('#add_save_item').click(function()
    {
        var $name = $('#new_item_name').val();
        $name = $.trim($name);

        if ($name !== '')
        {
            saveload.add_empty_item($name);
        }

        return false;
    });

    /* Инициализация различных элементов и кнопок */

    $('.info-save').click(function()
    {
        saveload.save($(this).parent());
        return false;
    });

    $('.info-load').click(function()
    {
        saveload.load($(this).parent());
        return false;
    });

    $('.info-del').click(function()
    {
        $(this).parent().remove();
        return false;
    });
    
    $('.save-load-item:first').find('.info-load').click();
    
    $(window).ready(function()
    {
        $('.insert-formula-list').remove();
    });
})(jQuery);

